package org.xbib.interlibrary.action.order;

import java.util.Collection;
import org.xbib.interlibrary.api.action.Request;

public class OrderRequest implements Request {

    private final Collection<Object> services;

    private final OrderRequester requester;

    protected OrderRequest(Builder builder) {
        this.services = builder.services;
        this.requester = builder.requester;
    }

    @Override
    public Collection<Object> getServices() {
        return services;
    }

    @Override
    public OrderRequester getRequester() {
        return requester;
    }

    @Override
    public Integer getOffset() {
        return 0;
    }

    @Override
    public Integer getSize() {
        return 0;
    }

    public static Builder builder() {
        return new Builder();
    }

    public static class Builder {

        Collection<Object> services;

        OrderRequester requester;

        Builder() {
        }

        public Builder setServices(Collection<Object> services) {
            this.services = services;
            return this;
        }

        public Builder setRequester(OrderRequester requester) {
            this.requester = requester;
            return this;
        }

        public OrderRequest build() {
            return new OrderRequest(this);
        }
    }

}
