package org.xbib.interlibrary.action.order;

import org.xbib.interlibrary.api.action.Response;
import org.xbib.interlibrary.api.action.ResponseBuilder;

public class OrderResponseBuilder implements ResponseBuilder<OrderRequest, OrderResponse> {

    private OrderRequest request;

    private Response.Status status;

    private Throwable throwable;

    OrderResponseBuilder() {
        status = Response.Status.UNDEFINED;
    }

    @Override
    public OrderResponseBuilder setRequest(OrderRequest request) {
        this.request = request;
        return this;
    }

    @Override
    public OrderResponseBuilder setStatus(String key, Response.Status status) {
        this.status = status;
        return this;
    }

    @Override
    public Response.Status getStatus() {
        return status;
    }


    public OrderResponseBuilder setThrowable(Throwable throwable) {
        this.throwable = throwable;
        return this;
    }

    @Override
    public Throwable getThrowable() {
        return throwable;
    }

    @Override
    public OrderResponseBuilder setThrowable(String key, String message, Throwable throwable) {
        this.throwable = throwable;
        return this;
    }

    @Override
    public OrderResponse build() {
        return new OrderResponse(request, status, this);
    }
}
